# coding: utf-8

"""
Code generated by OpenAPI Generator (https://openapi-generator.tech), manual changes will be lost - read more on https://github.com/algolia/api-clients-automation. DO NOT EDIT.
"""

from __future__ import annotations

from json import loads
from sys import version_info
from typing import Any, Dict, List, Optional, Union

from pydantic import BaseModel, ConfigDict

if version_info >= (3, 11):
    from typing import Self
else:
    from typing_extensions import Self


from algoliasearch.abtesting.models.ab_test import ABTest

_ALIASES = {
    "abtests": "abtests",
    "count": "count",
    "total": "total",
}


def _alias_generator(name: str) -> str:
    return _ALIASES.get(name, name)


class ListABTestsResponse(BaseModel):
    """
    ListABTestsResponse
    """

    abtests: Union[List[ABTest], None]
    """ The list of A/B tests, null if no A/B tests are configured for this application. """
    count: int
    """ Number of A/B tests. """
    total: int
    """ Number of retrievable A/B tests. """

    model_config = ConfigDict(
        strict=False,
        use_enum_values=True,
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
        alias_generator=_alias_generator,
        extra="allow",
    )

    def to_json(self) -> str:
        return self.model_dump_json(by_alias=True, exclude_unset=True)

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ListABTestsResponse from a JSON string"""
        return cls.from_dict(loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias."""
        return self.model_dump(
            by_alias=True,
            exclude_none=True,
            exclude_unset=True,
        )

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ListABTestsResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        obj["abtests"] = (
            [ABTest.from_dict(_item) for _item in obj["abtests"]]
            if obj.get("abtests") is not None
            else None
        )

        return cls.model_validate(obj)
